//// font size
var fontSize = function() {
  var elements = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6', '.btn'],
      elements_length = elements.length,
      elements_size = {};

  // get elements size with jquery after document ready
  $(document).ready(function() {
    for (var i = 0; i < elements_length; i++) {
      elements_size[elements[i]] = $(elements[i]).css('fontSize');
    }
  });

  // init
  $(document).ready(function() {
      size_c = readCookie('fontSize');
      if (size_c != null) reloadFontSize(size_c);
      else createCookie('fontSize', 0, 365);
  });

  function reloadFontSize(size) {
    var i = 0;
    size = (parseFloat(size) / 10) + 1;
    // change body zoom
    $('body').css('zoom', size, 'important');
    $('body').css('-moz-transform', "scale("+size+")", 'important');
    $('body').css('-moz-transform-origin', '0 0', 'important');

  }

  return {
    resizeText: function(increment) {
      var size = parseFloat(readCookie('fontSize'));
      increment = parseFloat(increment);
      if (increment === 0) size = 0;
      else if (((size > -6) && (increment < 0)) || ((size < 7) && (increment > 0))) {
        size = size + increment;
      };
      reloadFontSize(size);
      createCookie('fontSize', size, 365);
    }
  };
}

//// contrast
var contrast = function() {
  var contrast_elements = 'body, .barra-brasil, .search-bar, .learning-object-vertical .panel, .navbar, .well, .grey-panel, .btn, .user-header';

  // init
  $(document).ready(function() {
    run();
  });

  function run() {
    var contrast_c = readCookie('contrast');

    if (contrast_c == null || contrast_c != "true") {
      $(contrast_elements).removeClass('contraste');
      $('.search-bar').css('border-top','none');
      $('#menu-bar').removeClass('menu-bar-contrast');
      $('.navbar-header').removeClass('set-Colecao');
      $('.caret').css('border-top',' 7px solid black');
      $('.grey-panel').css('border','none');
      $('.button-cancel-setup').css('font-weight','normal');

      var select = $('.select-tag-container').select2()
      .on("select2:open", function() {
          // TODO: find a way to only apply contrast first time only
        if (select.length > 0) {
          select.each(function () {
            $(this).data('select2').$container.removeClass("selec");
            $(this).data('select2').$dropdown.removeClass("words");
            $(this).data('select2').$results.removeClass("fundo");
          });
        }
      });
    }
    else {
      $(contrast_elements).addClass('contraste');
      $('.search-bar').css('border-top','2px solid white');
      $('#menu-bar').addClass('menu-bar-contrast');
      $('.navbar-header').addClass('set-Colecao');
      $('.caret').css('border-top',' 7px solid white');
      $('.grey-panel').css('border','7px solid white');
      $('.button-cancel-setup').css('font-weight','bold');

      //contraste select2(menu esquerda)
      var select = $('.select-tag-container').select2()
      .on("select2:open", function() {
        // TODO: find a way to only apply contrast first time only
        if (select.length > 0) {
          select.each(function () {
            $(this).data('select2').$container.addClass("selec");
            $(this).data('select2').$dropdown.addClass("words");
            $(this).data('select2').$results.addClass("fundo");
          });
          $('.select2-search-choice:not(.my-custom-css)', this).addClass('my-custom-css');
        }
      });
    }
  }

  return {
    change: function() {
      (readCookie('contrast') == "true") ? createCookie('contrast',"false",0) : createCookie('contrast',"true",0);
      run();
    }
  };
}

//// cookies
//source: http://www.linhadecodigo.com.br/artigo/1615/acessibilidade-aumentando-e-diminuindo-tamanho-de-letra-em-seu-site.aspx
function createCookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	} else var expires = "";
	document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(";");
	for (var i=0;i < ca.length;i++)	{
		var c = ca[i];
		while (c.charAt(0)==" ") c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}

// define global variables
var fontSize = fontSize();
var contrast = contrast();

/*
function HandleBrowseClick()
{
    var fileinput = document.getElementById("browse");
    fileinput.click();
}
*/
