module OrientDb
  class ComplaintRepository < Base
    include OrientDb::Methods::EdgeMethods
    include RepositoriesProxy

      def report(complaint)
        if edge_exists?(odb_class, complaint.user.rid, complaint.object)
          false
        else
          connection.command "CREATE EDGE Complaint FROM #{complaint.user.rid} TO #{complaint.object} SET message = '#{complaint.message}', description = '#{complaint.description}'"
        end
      end

      def destroy(object)
        if !edge_exists?(odb_class, complaint.user.rid, complaint.object)
          raise "The object has not been reported by you yet."
        end

        connection.command "DELETE EDGE Complaint FROM #{complaint.user.rid} TO #{complaint.object}"
      end

      def build_object(args={})
        Complaint.new(args)
      end

      protected

      def odb_class
        "Complaint"
      end

  end
end
