module OrientDb
  class InstitutionRepository < Base
    include OrientDb::Methods::EdgeMethods

    # def create(name)
    #   connection.command sprintf("INSERT INTO Institution (name) VALUES ('%s')", name)
    # end

    # Usage:
    #   repository.for(:institutions).destroy institution
    #
    def destroy(institution)
      connection.command sprintf("DELETE VERTEX %s", institution.id)
    end

    def get_by_name(name)
      result = select_by_property(odb_class, "name", name)
      build_object result.first
    end

    def build_object(args={})
      if args.nil?
        return nil
      end

      return Institution.new(
        :id => args["@rid"],
        :name => args["name"]
      )
    end

    private

    def odb_class
      "Institution"
    end

  end
end
